/* session.pike
 *
 * Hller reda p allt som hr ihop med en uppkoppling */

#define WERROR werror

class _module_value
{
  // import Types;

  inherit Thread.Mutex; /* Ls fr sessionsobjektet */

  // inherit Server.Session;

  /* ndras aldrig efter create() */
  int session_no;
  object session;
  function(string:void) send_async;
  
  // inherit Thread.Mutex;

  int login(int person, string passwd, int is_invisible)
  {
    string crypted_passwd = Database.upersons->query_passwd(person);
    if (!crypted_passwd)
      return Errors.undef_pers;

    if (!crypt(passwd, crypted_passwd))
      return Errors.pwd;
    object key = lock();
    session->person = person;
    session->flags = is_invisible && Types.session_invisible;
    string username = session->username;
    //Database.sessions->update(session_no, a[0]);
    key = 0;
    /* XXX Skicka asynkrona meddelanden */
    if (Database.upersons->record_login(person, username))
      return 0;
    else
      return Errors.undef_pers;
  }

  int change_what_am_i_doing(string msg)
  {
    if (strlen(msg) > Config.query_var("max_what_length"))
      return Errors.long_str;

    object key = lock();
    session->what_am_i_doing = msg;
    // Database.sessions->update(session_no, a[0]);
    /* XXX Skicka asynkrona meddelanden */
    return 0;
  }

  int user_active()
  {
    object key = lock();
    session->flags |= Types.session_user_active_used;
    session->last_seen = time();
    // Database.sessions->update(session_no, a[0]);
    return 0;
  }

  array(string) who_is_on_dynamic(int want_visible,
				  int want_invisible,
				  int active_last)
  {
    if (!want_visible && !want_invisible)
      return ({ });
    array(int) sessions = Database.sessions->query_all_sessions();
    array(string) session_infos = allocate(sizeof(sessions));
    for (int i = 0; i < sizeof(sessions); i++)
      {
	//	WERROR("Session.who_is_on_dynamic: i = " + i + "\n");
	array a = 0;
	a = Database.sessions->lookup(sessions[i]);
	if (!a)
	  break;
	//	WERROR("Session.who_is_on_dynamic: a exists.\n");
	//	WERROR(sprintf("indices(a[0]) = %O\n", indices(a[0])));
	if (a[0]->query_and_update_idle_time() > active_last)
	  break;
	if ((a[0]->flags & Types.session_invisible) && !want_invisible)
	  break;
	if (!(a[0]->flags & Types.session_invisible) && !want_visible)
	  break;
	//	WERROR("Session.who_is_on_dynamic: a should be returned.\n");
	session_infos[i] = a[0]->query_dynamic();
      }
    //    WERROR(session_infos * "\n" + "\n");
    return session_infos - ({ 0 });
  }

  string get_static_session_info(int session_no)
  {
    array a = Database.sessions->lookup(session_no);
    return a && a[0]->query_static();
  }

  array(int) create_conf(string name, int type)
  {
    object key  = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return ({ Errors.login });

    if (type & Types.conf_letterbox)
      return ({ Errors.perm });

    if ( (type & Types.conf_secret) && !(type & Types.conf_rd_prot) )
      return ({ Errors.perm });
    
    return Database.create_conf(me, name, type);
  }
  
  array(int) create_person(string name, string passwd)
  {
    object key = lock();

    WERROR("Session->create_person\n");
    /* Hr r sessionen lst, och vi lser ett par andra tabeller
     * en i taget. */
    array res = Database.create_person(session->person, session->username,
				       name, crypt(passwd));
    WERROR("Session->create_person: foo\n");
    if (res[0])
      /* Misslyckat */
      return res;
    int old_person = session->person;
    string username = session->username;
    key = 0; /* Slpp lset */
    WERROR("Session->create_person: bar\n");
    
    if (!old_person)
      { /* Anropet lyckades, och vi var inte inloggade sen tidigare.
	 * Logga in som den nya personen. */
	session->person = res[1];
	WERROR("Session->create_person: statistik.\n");
	Database.upersons->record_login(res[1], username);
	WERROR("Session->create_person: statistik klart.\n");
      }
    return res;
  }

  array(int) create_text(string subject, string text, array misc_info)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return ({ Errors.login, 0 });

    if ( (strlen(subject) > Config.query_var("max_subject_length"))
	 || (strlen(text) > Config.query_var("max_text_length")) )
      return ({ Errors.long_str, 0 });

    int size = sizeof(misc_info);
    int i;
    object text_stat = Server.Text_Stat();

    text_stat->creation_time = time();
    text_stat->author = me;
    /* r det hr snyggt? */
    text_stat->no_of_lines = strlen(text) - strlen(text - "\n");
    text_stat->no_of_chars = strlen(text); /* Rknar inte med renderaden */
    text_stat->subject = subject;
    
    for(int i=0; i<size; i++)
      {
	switch(misc_info[i]->type)
	  {
	  case Types.misc_recipient:
	    if (!Database.may_access_conf(misc_info[i]->value, me))
	      return ({ Errors.undef_conf, i });
	    if (!Database.conferences
		->may_write_to_conf(misc_info[i]->value, me))
	      return ({ Errors.perm, i });

	    text_stat->recipients += ({ ({ misc_info[i]->value }) });
	    break;
	  case Types.misc_cc_recipient:
	    if (!Database.may_access_conf(misc_info[i]->value, me))
	      return ({ Errors.undef_conf, i });
	    if (!Database.conferences
		->may_write_to_conf(misc_info[i]->value, me))
	      return ({ Errors.perm, i });

	    text_stat->cc_recipients += ({ ({ misc_info[i]->value }) });
	    break;
	  case Types.misc_comment_to:
	    if (!Database.may_read_text(misc_info[i]->value, me))
	      return ({ Errors.no_such_text, i });

	    text_stat->comment_tos += ({ ({ misc_info[i]->value }) });
	    break;
	  case Types.misc_footnote_to:
	    if (Database.text_stats->query_author(misc_info[i]->value) != me)
	      return ({ Errors.not_author, i });

	    text_stat->footnote_tos += ({ ({ misc_info[i]->value }) });
	    break;

	  default:
	    return ({ Errors.ill_misc, i });
	  }
      }
    int text_no = Database.globals->next_text();

    foreach(text_stat->recipients + text_stat->cc_recipients,
	    array a)
      if (!Database.add_text_to_conf(a[0], text_no))
	werror("Session->create_text: Database.add_text() failed!\n");
    
    foreach(text_stat->comment_tos, array a)
      if (!Database.text_stats->add_comment_in(a[0], ({ text_no }) ))
	werror("Session->create_text: add_comment_in failed!\n");	

    foreach(text_stat->footnote_tos, array a)
      if (!Database.text_stats->add_footnote_in(a[0], ({ text_no })))
	werror("Session->create_text: add_footnote_in failed!\n");	

    Database.texts->store(text_no, Server.Text(text));
    Database.text_stats->store(text_no, text_stat);
    
    if (!Database.created_texts->add_text(me, text_no))
      werror("Session->create_text: created_texts->add_text() failed!\n");

    if (!Database.upersons->record_created_text(me))
      werror("Session->create_text: record_created_text failed!\n");
    
    return ({ 0, text_no });
  }

  array get_text_stat(int text_no)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    /* XXX motd_of_lyskom ska man kunna lsa utan att logga in. */
    if (!me)
      return ({ Errors.login });

    if (!text_no)
      return ({ Errors.text_zero });

    if (!Database.may_read_text(text_no, me))
      return ({ Errors.no_such_text });
    
    array a = Database.text_stats->lookup(text_no);
    if (!a)
      return ({ Errors.no_such_text });

    object text_stat = Types.Text_Stat();

    text_stat->creation_time = a[0]->creation_time;
    text_stat->author = a[0]->author;
    text_stat->no_of_lines = a[0]->no_of_lines;
    text_stat->no_of_chars = a[0]->no_of_chars + sizeof(a[0]->subject) + 1;
    text_stat->no_of_marks = a[0]->no_of_marks;
    text_stat->misc_info = a[0]->query_misc_info(text_no);

    a = 0;
    return ({ 0, text_stat });
  }

  array get_text_interval(int text_no, int start_char, int end_char)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    /* XXX motd_of_lyskom ska man kunna lsa utan att logga in. */
    if (!me)
      return ({ Errors.login });

    if (!text_no)
      return ({ Errors.text_zero });
    
    if (!Database.may_read_text(text_no, me))
      return ({ Errors.no_such_text });

    array ts = Database.text_stats
      ->query_vars(text_no, ({ "subject", "no_of_chars" }) );
    if (!ts)
      return ({ Errors.no_such_text });
    string subject = ts[0];
    int size = sizeof(subject) + 1 + ts[1];
    if (start_char > size)
      return ({ Errors.index_out_of_range });
    if (start_char == size)
      return ({ 0, "" });
    
    string text = Database.texts->query_text(text_no);
    if (!text)
      return ({ Errors.no_such_text });

    text = subject + "\n" + text;
    if (sizeof(text) != size)
      {
	werror("Session->get_text_interval: Size info in database was invalid!\n");
	size = sizeof(text);
	if (start_char > size)
	  return ({ Errors.index_out_of_range });
	if (start_char == size)
	  return ({ 0, "" });
      }
    if (end_char >= size)
      return ({ 0, text[start_char..] });
    else
      return ({ 0, text[start_char..end_char-1] });
  }
        
  int add_member(int conf_no, int pers_no, int priority, int where)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return Errors.login;

    if (!conf_no)
      return Errors.conf_zero;

    if (!Database.may_access_conf(conf_no, me))
      return Errors.undef_conf;

    int type = Database.uconferences->query_type(conf_no);
    if (type < 0)
      return Errors.undef_conf;

    /* Reglerna:
     *
     * Om me r organisatr fr pers_no, s fr man addera pers_no
     * till samtliga mten som me fr komma t, och som antingen r
     *
     *  ppna, eller
     *
     *  har pers_no som medlem, eller
     *
     *  me r organisatr fr.
     *
     * Om me inte r organisatr fr pers_no, s fr man addera
     * pers_no till mten som
     *
     *  Inte r ppna (dvs skyddade eller hemliga), och
     *
     *  me r organisatr fr eller medlem i, och
     *
     *  pers_no inte redan r medlem i.
     *
     */

    if ( (me == pers_no) || Database.supervises(pers_no, me))
      {
	if ( (type & (Types.conf_secret | Types.conf_rd_prot))
	     && !Database.supervises(conf_no, me)
	     && !Database.conferences->is_member(conf_no, pers_no) )
	  return Errors.access;

	return Database.add_member(conf_no, pers_no, priority, 1, where);
      }
    else
      {
	if ( ! ( (type & (Types.conf_secret | Types.conf_rd_prot))
		 && (Database.supervises(conf_no, me)
		     || Database.conferences->is_member(conf_no, me))))
	  return Errors.access;
	
	return Database.add_member(conf_no, pers_no, priority, 0, where);
      }
  }

  array get_memberships(int person, int first, int no_of_confs, int mask)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return ({ Errors.login });

    if (!Database.may_access_conf(person, me))
      return ({ Errors.undef_conf });
    
    array a = Database.memberships->lookup(person);
    if (!a)
      return ({ Errors.undef_pers });

    // WERROR(sprintf("Session->get_memberships: a = %O\n", a));
    // WERROR(sprintf("Session->get_memberships: indices(a[0]) = %O\n",
    //	   indices(a[0])));
    if (first >= sizeof(a[0]->memberships))
      return ({ Errors.index_out_of_range });

    int last = first + no_of_confs;
    if (last > sizeof(a[0]->memberships))
      last = sizeof(a[0]->memberships);
    
    /* Censurera hemliga m|ten */
#if 1
    array(object) res
      = Array.map(a[0]->memberships[first..last - 1],
		     lambda(object m, int me) {
	return Database.may_access_conf(m->conference, me) && m;
      }, me);
#else
    array(object) res
      = Array.filter(a[0]->memberships[first..last - 1],
		     lambda(object m, int me) {
	return Database.may_access_conf(m->conference, me);
      }, me);
#endif    
    res = Array.map(res, lambda(object m)
		    { return m ? m->query_old_membership()
			: Types.Membership(); } );

    a = 0; /* Slpp lset */
    
    if (mask)
      /* Bygg listor av lsta texter efter last_text_read */
      foreach(res, object m)
	{
	  if (m->conference)
	    { /* Ej censurerad */
	      array(int) texts = Database.conf_texts
		->query_texts_after(m->conference, m->last_text_read);
	      if (!texts)
		return ({ Errors.undef_conf });
	      array a = Database.unread->lookup(person);
	      if (!a)
		{
		  werror(sprintf("No membership data for person %d!\n",
				 person));
		  return ({ Errors.undef_pers });
		}
	      m->read_texts = a[0]->query_read(texts);
	      a = 0;
	    }
	  else
	    m->read_texts = ({ });
	}
    return ({ 0, res });
  }

  array query_membership(int person, int conf)
  {
    if (!conf)
      return ({ Errors.conf_zero });

    object key = lock();
    int me = session->person;
    key = 0;

    if (!Database.may_access_conf(conf, me))
      return ({ Errors.undef_conf });

    if (!Database.may_access_conf(person, me))
      return ({ Errors.undef_pers });

    if (!Database.conferences->is_member(conf, me))
      return ({ Errors.not_member });

    array a = Database.memberships->query_membership(person, conf);
    if (!a)
      return ({ Errors.not_member });

    object m = a[0]->query_old_membership();
    int change_count = a[0]->change_count;
    int first_unread = a[0]->first_unread;
    a = 0;

    array(int) texts = Database.conf_texts
      ->query_texts_after(m->conference, first_unread - 1);
    if (!texts)
      return ({ Errors.undef_conf });

    array a = Database.unread->lookup(person);
    if (!a)
      return ({ Errors.undef_pers });

    int first_unread = a[0]->next_unread_text(first_unread, texts);

    m->read_texts = a[0]->query_read(texts);
    a = 0;

    Database.memberships->increase_first_unread(person, conf,
						change_count, first_unread);
    return ({ 0, m });
  }

  int mark_as_read(array(int) texts)
  {
    WERROR(sprintf("Session->mark_as_read: %O\n", texts));
    
    object key = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return Errors.login;

    if (search(texts, 0) >= 0)
      return Errors.text_zero;

    return Database.unread->mark_as_read(me, texts);
  }
  
  array get_map(int conf_no, int start, int no_of_texts)
  {
    if (!conf_no)
      return ({ Errors.conf_zero });

    object key = lock();
    int me = session->person;
    key = 0;

    if (!me)
      return ({ Errors.login });
    if (!Database.may_access_conf(conf_no, me))
      return ({ Errors.undef_conf });
    if (!Database.may_read_conf(conf_no, me))
      return ({ Errors.access });

    if (!no_of_texts)
      return ({ 0, ({ }) });

    if (!start)
      return ({ Errors.no_such_local_text });

    int last = Database.conf_texts->query_last_text(conf_no);
    if (!last || (last < start))
      return ({ Errors.no_such_local_text });

    int end = start + no_of_texts - 1;
    if (last < end)
      end = last;
    
    array(int) res = Database.conf_texts
      ->query_texts_interval(conf_no, start, end);
    if (!res)
      return ({ Errors.undef_conf });
    
    array map = allocate(end - start + 1);
    foreach(res, int text)
      map[text - start] = text;
    return ({ 0, start, map });
  }
      
  array get_conf_stat(int conf_no)
  {
    object key = lock();
    int me = session->person;
    key = 0;

//    if (!me)
//      return ({ Errors.login });
    if (!Database.may_access_conf(conf_no, me))
      return ({ Errors.undef_conf });
    
    object conf_stat = Types.Conference();
    
    array uconf = Database->uconferences->query_vars(conf_no, ({
      "name", "type", "nice" }) );
    if (!uconf)
      return ({ Errors.undef_conf });
    conf_stat->name = uconf[0];
    conf_stat->type = uconf[1];
    conf_stat->nice = uconf[2];
    
    array a = Database.conferences->lookup(conf_no);
    if (!a)
      return ({ Errors.undef_conf });
    
    conf_stat->creation_time = a[0]->creation_time;
    conf_stat->last_written = a[0]->last_written;
    conf_stat->creator = a[0]->creator;
    conf_stat->presentation = a[0]->presentation;
    conf_stat->supervisor = a[0]->supervisor;
    conf_stat->permitted_submitters = a[0]->permitted_submitters;
    conf_stat->super_conf = a[0]->super_conf;
    conf_stat->msg_of_day = a[0]->msg_of_day;
    conf_stat->no_of_members = sizeof(a[0]->members);
    a = 0;
    conf_stat->first_local_no = Database.conf_texts->query_first_text(conf_no);
    conf_stat->no_of_texts = Database.conf_texts->query_no_texts(conf_no);

    return ({ 0, conf_stat });
  }

  array get_person_stat(int pers_no)
  {
    object key = lock();
    int me = session->person;
    key = 0;

    if (!Database.may_access_conf(pers_no, me))
      return ({ Errors.undef_pers });

    object res = Types.Person();

    array a = Database.upersons->lookup(pers_no);
    if (!a)
      return ({ Errors.undef_pers });

    /* Returnera nyckeln, s lset behlls tills person-staten r
     * konverterad till protokoll A. */
    return ({ 0, @a });
  }

  int who_am_i()
  {
    return session_no;
  }
  
  array(object) filter_z_info(array(object) confs, int person,
			      int want_confs, int want_pers)
  {
    WERROR(sprintf("Session->filter_z_info: want_confs=%d, want_pers=%d\n",
		   want_confs, want_pers));
    if (!want_confs)
      confs = Array.filter(confs, lambda(object c)
			   { return c->type & Types.conf_letterbox; });
    else if (!want_pers)
      confs = Array.filter(confs, lambda(object c)
			   { return !(c->type & Types.conf_letterbox); });
    return Array.filter(confs, lambda(object c, int person)
			{
			  // WERROR(sprintf("Session.filter_z_info: "
			  // "type = %d\n", c->type));
			  if (!(c->type & Types.conf_secret))
			    /* Ohemligt */
			    return 1;
			  return person && Database.conferences
			    ->is_member(c->conf_no, person);
			}, person);
  }
  
  array(object) lookup_z_name(string name, 
			      int want_confs, int want_pers)
  {
    WERROR(sprintf("Session->lookup_z_name: want_confs=%d, want_pers=%d\n",
		   want_confs, want_pers));
    if (!(want_confs || want_pers))
      return ({ });

    object key = lock();
    int me = session->person;
    key = 0;
    
    array confs = Database.uconferences->query_z_info();
    // WERROR(sprintf("Session->lookup_z_name: Conferences: %{'%s',\n%}\n",
    // column(confs, "name")));
    confs = Array.filter(confs, lambda(object c, array(string) name)
			 {
			   array(string) words
			     = Misc.kom_simplify_name(c->name);
			   // WERROR(sprintf("Comparing %O, %O\n", name, words));
			   for(int i = 0; i<sizeof(name); i++)
			     if (name[i]
				 != words[i][..sizeof(name[i])-1])
			       return 0;
			   return 1;
			 }, Misc.kom_simplify_name(name));
    // WERROR(sprintf("Session->lookup_z_name: left: %{'%s',\n%}\n",
    // column(confs, "name")));
    return filter_z_info(confs, me, want_confs, want_pers);
  }

  array info_old()
  {
    return ({ 10900 }) + Database.globals->query_vars( ({
      "conf_pres_conf", "pers_pres_conf", "motd_conf",
      "kom_news_conf", "motd_of_lyskom" }) );
  }

  array version_info()
  {
    return ({ 9, "lyskomd.pike", "0.001" });
  }

  void create(string name, function(string:void) f)
  {
    session_no = Database.session_counter->next();
    session = Server.Session();
    session->session = session_no;
    session->connection_time = time();
    session->username = name;
    session->hostname = "";	/* Temporrlsning */
    session->ident_user = "";	/* Temporrlsning */
    send_async = f;
    Database.sessions->remember(session_no, this_object());
  }

  void delete()
  {
    Database.sessions->forget(session_no);
  }
}
